package ee.deleniewebapp;

import jakarta.enterprise.context.SessionScoped;
import jakarta.inject.Named;
import jakarta.ws.rs.client.Client;
import jakarta.ws.rs.client.ClientBuilder;
import jakarta.ws.rs.client.ClientRequestContext;
import jakarta.ws.rs.client.ClientRequestFilter;

import java.io.IOException;
import java.io.Serializable;

@Named
@SessionScoped
public class Delic implements Serializable, ClientRequestFilter {

    public Delic() { }

    @Override
    public void filter(ClientRequestContext ctx) throws IOException
    {
        System.out.println("logujem pristup: " + ctx.getUri());
    }

    private int delenec, delitel;
    private boolean vysledok;
    private String err;

    public int getDelenec() {
        return delenec;
    }

    public void setDelenec(int delenec) {
        this.delenec = delenec;
    }

    public int getDelitel() {
        return delitel;
    }

    public void setDelitel(int delitel) {
        this.delitel = delitel;
    }

    public boolean isVysledok() {
        Client client = ClientBuilder.newClient();
        client.register(Delic.class);
        try {
            vysledok = client
                    .target("http://localhost:8080/DelenieService-1.0-SNAPSHOT/service/delenie")
                    .path("{delenec}/{delitel}")
                    .resolveTemplate("delenec", delenec)
                    .resolveTemplate("delitel", delitel)
                    .request()
                    .get(Boolean.class);
        } catch (Exception e)
        {
            err = "chyba: " + e.toString();
        }
        return vysledok;
    }

    public void setVysledok(boolean vysledok) {
        this.vysledok = vysledok;
    }

    public void setErr(String err) {
        this.err = err;
    }

    public String getErr() {
        return err;
    }
}
